var albumBlock = {
	
	init: function(){ 
			this.tabSetup();
			this.toggleOptions();
	},
	
	tabSetup: function(){
		$('ul#ccm-albumblock-tabs li a').each( function(num,el){ 
			el.onclick=function(){
				var pane=this.id.replace('ccm-albumblock-tab-','');
				albumBlock.showPane(pane);
			}
		});		
	},
	
	showPane: function(pane){
		$('ul#ccm-albumblock-tabs li').each(function(num,el){ $(el).removeClass('ccm-nav-active') });
		$(document.getElementById('ccm-albumblock-tab-'+pane).parentNode).addClass('ccm-nav-active');
		$('div.ccm-albumblockpane').each(function(num,el){ el.style.display='none'; });
		$('#ccm-albumblockpane-'+pane).css('display','block');
	},	
	
	toggleOptions: function(){
		var checkbox_dimming = document.getElementById('dimming');
		var checkbox_credits = document.getElementById('credits');
		var checkbox_alttags = document.getElementById('alttags');
		
		if (checkbox_dimming.checked != true) {
			$(".albumBlockSetup tr[id=dimmingopacity]").hide();
		}
		
		if (checkbox_credits.checked != true) {
			$(".albumBlockSetup tr[id=creditsurl]").hide();
			$(".albumBlockSetup tr[id=creditstitle]").hide();
			$(".albumBlockSetup tr[id=creditstext]").hide();
		}
		
		if (checkbox_alttags.checked != true) {
			$(".albumBlockSetup tr[id=caption_attribs_title]").hide();
			$(".albumBlockSetup tr[id=caption_attribs]").hide();
		}
	},
	
	chooseImg:function(){ 
		ccm_launchFileManager('&fType=' + ccmi18n_filemanager.FTYPE_IMAGE);
	},
	
	showImages:function(){
		$("#ccm-albumBlock-imgRows").show();
		$("#ccm-albumBlock-chooseImg").show();
		$("#ccm-albumBlock-fsRow").hide();
	},

	showFileSet:function(){
		$("#ccm-albumBlock-imgRows").hide();
		$("#ccm-albumBlock-chooseImg").hide();
		$("#ccm-albumBlock-fsRow").show();
	},

	selectObj:function(obj){
		if (obj.fsID != undefined) {
			$("#ccm-albumBlock-fsRow input[name=fsID]").attr("value", obj.fsID);
			$("#ccm-albumBlock-fsRow input[name=fsName]").attr("value", obj.fsName);
			$("#ccm-albumBlock-fsRow .ccm-albumBlock-fsName").text(obj.fsName);
		} else {
			this.addNewImage(obj.fID, obj.thumbnailLevel1, obj.height, obj.title);
		}
	},

	addImages:0, 
	addNewImage: function(fID, thumbPath, imgHeight, title) { 
		this.addImages--; //negative counter - so it doesn't compete with real slideviewerImgIds
		var slideviewerImgId=this.addImages;
		var templateHTML=$('#imgRowTemplateWrap .ccm-albumBlock-imgRow').html().replace(/tempFID/g,fID);
		templateHTML=templateHTML.replace(/tempThumbPath/g,thumbPath);
		templateHTML=templateHTML.replace(/tempFilename/g,title);
		templateHTML=templateHTML.replace(/tempSlideviewerImgId/g,slideviewerImgId).replace(/tempHeight/g,imgHeight);
		var imgRow = document.createElement("div");
		imgRow.innerHTML=templateHTML;
		imgRow.id='ccm-albumBlock-imgRow'+parseInt(slideviewerImgId);	
		imgRow.className='ccm-albumBlock-imgRow';
		document.getElementById('ccm-albumBlock-imgRows').appendChild(imgRow);
		var bgRow=$('#ccm-albumBlock-imgRow'+parseInt(fID)+' .backgroundRow');
		bgRow.css('background','url('+thumbPath+') no-repeat left top');
	},
	
	removeImage: function(fID){
		$('#ccm-albumBlock-imgRow'+fID).remove();
	},
	
	moveUp:function(fID){
		var thisImg=$('#ccm-albumBlock-imgRow'+fID);
		var qIDs=this.serialize();
		var previousQID=0;
		for(var i=0;i<qIDs.length;i++){
			if(qIDs[i]==fID){
				if(previousQID==0) break; 
				thisImg.after($('#ccm-albumBlock-imgRow'+previousQID));
				break;
			}
			previousQID=qIDs[i];
		}	 
	},
	moveDown:function(fID){
		var thisImg=$('#ccm-albumBlock-imgRow'+fID);
		var qIDs=this.serialize();
		var thisQIDfound=0;
		for(var i=0;i<qIDs.length;i++){
			if(qIDs[i]==fID){
				thisQIDfound=1;
				continue;
			}
			if(thisQIDfound){
				$('#ccm-albumBlock-imgRow'+qIDs[i]).after(thisImg);
				break;
			}
		} 
	},
	serialize:function(){
		var t = document.getElementById("ccm-albumBlock-imgRows");
		var qIDs=[];
		for(var i=0;i<t.childNodes.length;i++){ 
			if( t.childNodes[i].className && t.childNodes[i].className.indexOf('ccm-albumBlock-imgRow')>=0 ){ 
				var qID=t.childNodes[i].id.replace('ccm-albumBlock-imgRow','');
				qIDs.push(qID);
			}
		}
		return qIDs;
	},	

	validate:function(){
		var failed=0; 
		
		if ($("#ccm-albumblockpane-imgs select[name=type]").val() == 'FILESET')
		{
			if ($("#ccm-albumBlock-fsRow input[name=fsID]").val() <= 0) {
				alert(ccm_t('choose-fileset'));
				$('#ccm-albumBlock-AddImg').focus();
				failed=1;
			}	
		} else {
			qIDs=this.serialize();
			if( qIDs.length<1 ){
				alert(ccm_t('choose-min-2'));
				$('#ccm-albumBlock-AddImg').focus();
				failed=1;
			}	
		}
		
		if(failed){
			ccm_isBlockError=1;
			return false;
		}
		return true;
	} 

}


ccmValidateBlockForm = function() { return albumBlock.validate(); }
ccm_chooseAsset = function(obj) { albumBlock.selectObj(obj); }

$(function() {

	if ($("#ccm-albumblockpane-imgs select[name=type]").val() == 'FILESET') {
		$("#ccm-albumblockpane-imgs select[name=type]").val('FILESET');
		albumBlock.showFileSet();
	} else {
		$("#ccm-albumblockpane-imgs select[name=type]").val('CUSTOM');
		albumBlock.showImages();
	}

	$("#ccm-albumblockpane-imgs select[name=type]").change(function(){
		if (this.value == 'FILESET') {
			albumBlock.showFileSet();
		} else {
			albumBlock.showImages();
		}
	});


	$(".albumBlockSetup input[name=dimming]").change(function(){
		if (this.checked == true) {
			$(".albumBlockSetup tr[id=dimmingopacity]").show();
		} else {
			$(".albumBlockSetup tr[id=dimmingopacity]").hide();
		}
	});
	

	$(".albumBlockSetup input[name=credits]").change(function(){
		if (this.checked == true) {
			$(".albumBlockSetup tr[id=creditsurl]").show();
			$(".albumBlockSetup tr[id=creditstitle]").show();
			$(".albumBlockSetup tr[id=creditstext]").show();
		} else {
			$(".albumBlockSetup tr[id=creditsurl]").hide();
			$(".albumBlockSetup tr[id=creditstitle]").hide();
			$(".albumBlockSetup tr[id=creditstext]").hide();
		}
	});
	
	$(".albumBlockSetup input[name=alttags]").change(function(){
		if (this.checked == true) {
			$(".albumBlockSetup tr[id=caption_attribs_title]").show();
			$(".albumBlockSetup tr[id=caption_attribs]").show();
		} else {
			$(".albumBlockSetup tr[id=caption_attribs_title]").hide();
			$(".albumBlockSetup tr[id=caption_attribs]").hide();
		}
	});

});

$(document).ready(function(){albumBlock.init()});